#include<iostream>
#include<math.h>
#include<vector>
using namespace std;

const int MAXN=1e7+1;
bool sieve[MAXN];
vector<long long> primes;

void GetPrimes(int n)
{
    for(int i=0; i<n; i++)
    {
        sieve[i]=false;
    }

    for(int i=2; i<n; i++)
    {
        if(sieve[i]==false)
        {
            primes.push_back((long long)i*i);
            for(long long j=(long long)i*i; j<n; j+=i)
            {
                sieve[j]=true;
            }
        }
    }

    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    GetPrimes(MAXN);

    int q;
    cin >> q;

    while(q--)
    {
        long long n;
        cin >> n;

        long long ans=n;
        int m=primes.size();
        for(int i=0; i<m; i++)
        {
            long long l=1, r=n, cnt1=0;
            while(l<=r)
            {
                long long mid=l+(r-l)/2;
                if(primes[i]*mid<=n)
                {
                    cnt1=mid;
                    l=mid+1;
                }
                else
                {
                    r=mid-1;
                }
            }

            l=0, r=m-1;
            int cnt2=-1;
            while(l<=r)
            {
                int mid=l+(r-l)/2;
                if(primes[mid]<=cnt1)
                {
                    cnt2=mid;
                    l=mid+1;
                }
                else
                {
                    r=mid-1;
                }
            }

            ans-=cnt1-(cnt2+1);
        }

        cout << ans << "\n";
    }

    return 0;
}

