#include<iostream>
#include<math.h>
#include<vector>
using namespace std;

const int MAXN=1e7+1;
bool sieve[MAXN], hasSquare[MAXN];
vector<long long> primes;
vector<long long> squares;

void GetPrimes(int n)
{
    primes.clear();
    squares.clear();
    for(int i=0; i<n; i++)
    {
        sieve[i]=true;
        hasSquare[i]=false;
    }

    for(int i=2; i<n; i++)
    {
        if(sieve[i])
        {
            primes.push_back(i);
            for(long long j=(long long)i*i; j<n; j+=i)
            {
                sieve[j]=false;
            }

            if((long long)i*i<n)
            {
                hasSquare[(long long)i*i]=true;
                for(long long j=(long long)i*i*i; j<n; j+=(long long)i*i)
                {
                    hasSquare[j]=true;
                }
            }
        }
        else if(!hasSquare[i])
        {
            squares.push_back(i);
        }
    }

    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int q;
    cin >> q;

    while(q--)
    {
        long long n;
        cin >> n;

        GetPrimes(n+1);
        cout << primes.size() + squares.size() + 1 << "\n";

        /*long long ans=n;
        int m=primes.size();
        for(int i=0; i<m; i++)
        {
            long long l=1, r=n, cnt1=0;
            while(l<=r)
            {
                long long mid=l+(r-l)/2;
                if(primes[i]*mid<=n)
                {
                    cnt1=mid;
                    l=mid+1;
                }
                else
                {
                    r=mid-1;
                }
            }

            l=0, r=i-1;
            int cnt2=-1;
            while(l<=r)
            {
                int mid=l+(r-l)/2;
                if(primes[mid]<=cnt1)
                {
                    cnt2=mid;
                    l=mid+1;
                }
                else
                {
                    r=mid-1;
                }
            }

            //cout << primes[i] << " => " << cnt1 << " => " << cnt2 << "\n";

            ans-=cnt1-(cnt2+1);
        }

        cout << ans << "\n";*/
    }

    return 0;
}

