#include <iostream>
#include <vector>
#include <cmath>
#define endl '\n'
using namespace std;

const int MAXP = 1e7;

bool e[MAXP + 5];
vector<int> primes;

void sieve()
{
    e[1] = true;
    for (int i = 2; i <= MAXP; ++ i)
    {
        if (!e[i])
        {
            primes.push_back(i);
            for (long long j = 1ll * i * i; j <= MAXP; j += i)
            {
                e[j] = true;
            }
        }
    }
}

void solve()
{
    long long n;
    cin >> n;

    long long cnt = 0;
    vector<long long> active, tmp;
    for (auto num : primes)
    {
        long long t = 1ll * num * num;
        if (t <= n)
        {
            active.push_back(t);
            cnt += n / t;
        }
    }

    int c = -1;
    while (active.size())
    {
        for (auto num : active)
        {
            for (auto num1 : primes)
            {
                long long t = num * num1 * num1;
                if (t > n) break;
                if (num % num1 == 0) continue;
                tmp.push_back(t);
                cnt += c * n / t;
            }
        }
        active = tmp;
        tmp.clear();
        c *= -1;
    }

    cout << n - cnt << endl;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    sieve();

    int q;
    cin >> q;

    while (q--)
    {
        solve();
    }

    return 0;
}
