#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#define endl '\n'
using namespace std;

const int MAXP = 10000000;

bool e[MAXP + 5];
vector<int> primes;

void sieve()
{
    e[1] = true;
    for (int i = 2; i <= MAXP; ++ i)
    {
        if (!e[i])
        {
            primes.push_back(i);
            for (long long j = 1ll * i * i; j <= MAXP; j += i)
            {
                e[j] = true;
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    sieve();

    int q;
    cin >> q;

    vector< pair<long long, int> > active, tmp;
    while (q--)
    {
        long long n;
        cin >> n;

        long long cnt = 0;
        active.clear();
        for (auto p : primes)
        {
            long long t = 1ll * p * p;
            if (t <= n)
            {
                long long q = (n - 1) / t + 1;
                if (t * (p + 1) * (p + 1) <= n) active.push_back({t, p});
                cnt += n / t;
            }
        }

        int c = -1;
        int loops = 0;
        do
        {
            ///cout << active.size() << endl;
            tmp.clear();
            for (auto [num1, num2] : active)
            {
                int pos = lower_bound(primes.begin(), primes.end(), num2 + 1) - primes.begin();
                for (int i = pos; i < primes.size(); ++ i)
                {
                    int p = primes[i];
                    long long q = (n - 1) / (1ll * p * p) + 1;
                    if (num1 > q) break;
                    if (num1 % p == 0) continue;
                    long long t = 1ll * num1 * p * p;
                    q = (n - 1) / t + 1;
                    if ((p + 1) * (p + 1) <= q) tmp.push_back({t, p});
                    cnt += c * n / t;
                }
            }
            active = tmp;
            c *= -1;
            loops++;
        } while (active.size());
        ///cout << loops << endl;

        cout << n - cnt << endl;
    }

    return 0;
}
