#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXP = 10000000;

int wh[10];
bool e[MAXP + 5];
vector<int> primes;
long long n[505], cnt[505];
pair<long long, int> active[10][6000];

void sieve()
{
    e[1] = true;
    for (int i = 2; i <= MAXP; ++ i)
    {
        if (!e[i])
        {
            primes.push_back(i);
            for (long long j = 1ll * i * i; j <= MAXP; j += i)
            {
                e[j] = true;
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    sieve();
    primes.push_back(MAXP + 1);
    int sz = primes.size();

    int q;
    cin >> q;

    long long N = 0;
    for (int i = 1; i <= q; ++ i)
    {
        cin >> n[i];
        N = max(N, n[i]);
    }

    vector<long long> vp, vm;
    for (int i = 0; i < sz - 1; ++ i)
    {
        int p = primes[i], p1 = primes[i + 1];
        long long t = 1ll * p * p;
        if (t > N) break;
        long long d = N / t + 1;
        if (1ll * p1 * p1 < d) active[1][wh[1]++] = {t, i};
        else vm.push_back(t);
    }

    int curr = 2;
    while (true)
    {
        for (int i = 0; i < wh[curr - 1]; ++ i)
        {
            long long num = active[curr - 1][i].first;
            int pos = active[curr - 1][i].second + 1;
            for (int j = pos; j < sz - 1; ++ j)
            {
                int p = primes[j], p1 = primes[j + 1];
                long long d = N / (1ll * p * p);
                if (num > d) break;
                if (num % p == 0) continue;
                long long t = 1ll * num * p * p;
                d = N / t + 1;
                if (1ll * p1 * p1 < d) active[curr][wh[curr]++] = {t, j};
                else
                {
                    if (curr % 2) vm.push_back(t);
                    else vp.push_back(t);
                }
            }
        }
        if (wh[curr] == 0) break;
        curr++;
    }

    sort(vp.begin(), vp.end());
    sort(vm.begin(), vm.end());

    for (int i = 1; i <= q; ++ i)
    {
        cnt[i] = n[i];
        int c = -1;
        for (int j = 1; j <= curr; ++ j)
        {
            for (int k = 0; k < wh[j]; ++ k)
            {
                cnt[i] += c * n[i] / active[j][k].first;
            }
            c *= -1;
        }

        int p = vp.size() - 1;
        for (int j = 0; p > 100000; ++ j)
        {
            int t = lower_bound(vp.begin(), vp.end(), n[i] / (j + 1) + 1) - vp.begin();
            cnt[i] += 1ll * j * (p - t + 1);
            p = t - 1;
        }

        for (int j = 0; j <= p; ++ j)
        {
            cnt[i] += n[i] / vp[j];
        }

        p = vm.size() - 1;
        for (int j = 0; p > 100000; ++ j)
        {
            int t = lower_bound(vm.begin(), vm.end(), n[i] / (j + 1) + 1) - vm.begin();
            cnt[i] -= 1ll * j * (p - t + 1);
            p = t - 1;
        }

        for (int j = 0; j <= p; ++ j)
        {
            cnt[i] -= n[i] / vm[j];
        }

        cout << cnt[i] << endl;
    }

    return 0;
}
