#include <iostream>
#include <vector>

#define endl '\n'

using namespace std;

const int64_t MAXN = 1e7 + 3;
bool not_prime[MAXN];
vector<int64_t> primes;

void prime_numbers()
{
    primes.push_back(2);

    for (int64_t i = 4; i < MAXN; i += 2ll)
    {
        not_prime[i] = true;
    }

    for (int64_t i = 3; i < MAXN; i += 2ll)
    {
        if (!not_prime[i])
        {
            primes.push_back(i);

            for (int64_t j = i * i; j < MAXN; j += i)
            {
                not_prime[j] = true;
            }
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;

    prime_numbers();

    for (int i = 0; i < q; ++i)
    {
        int64_t n;
        cin >> n;

        int64_t result = n;

        for (int64_t curr_prime : primes)
        {
            if (curr_prime * curr_prime > n)
            {
                break;
            }

            result -= (n / (curr_prime * curr_prime));
        }

        cout << result << endl;
    }

    return 0;
}
