#include <iostream>
#include <vector>
#include <algorithm>

#define endl '\n'

using namespace std;

const int MAX_SUM = 25e4 + 3;

int query(int l, int r, int a, int b, vector<int>& money)
{
    vector<bool> dp(MAX_SUM, false);
    dp[0] = true;

    for (int i = l; i <= r; ++i)
    {
        for(int j = MAX_SUM - 1; j >= money[i]; --j)
        {
            dp[j] = (dp[j] | dp[j - money[i]]);
        }
    }

    int result = 0;
    for (int i = a; i <= b; ++i)
    {
        result += dp[i];
    }

    return result;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<int> money(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> money[i];
    }

    for (int i = 0; i < q; ++i)
    {
        int l, r, a, b;
        cin >> l >> r >> a >> b;

        --l;
        --r;

        cout << query(l, r, a, b, money) << endl;
    }

    return 0;
}

