#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int maxs = 25e4+2, maxn = 512, maxk = 15e5+2;
struct query
{
    int l, r;
    int x, y;
    int idx;
};
query q[maxk];
int n, k, a[maxn], lead[maxk], p[maxn], idx_dp, t[4*maxs], ans[maxk], ql, qr;
bool dp[2][maxs];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> k ;
    for (int i=1; i<=n; ++i)
    {
        cin >> a[i] ;
        p[i] = p[i-1] + a[i];
    }
    for (int i=1; i<=k; ++i)
    {
        cin >> q[i].l >> q[i].r >> q[i].x >> q[i].y ;
        q[i].idx = i;
    }
}

bool cmp(query q1, query q2)
{
    if (q1.l == q2.l) return (q1.r > q2.r);
    return (q1.l < q2.l);
}

void make_tree(int i, int l, int r)
{
    if (l == r)
    {
        t[i] = (int)(dp[idx_dp][r]);
        return;
    }
    int mid = (l+r) >> 1;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);
    t[i] = t[2*i] + t[2*i+1];
}

int query_sum(int i, int l, int r)
{
    if (l > qr || r < ql) return 0;
    if (l >= ql && r <= qr) return t[i];
    int mid = (l+r) >> 1;
    return query_sum(2*i, l, mid) + query_sum(2*i+1, mid+1, r);
}
void update(int i, int l, int r, int pos)
{
    if (l == r)
    {
        t[i] = 1;
        return;
    }
    int mid = (l+r) >> 1;
    if (pos <= mid) update(2*i, l, mid, pos);
    else update(2*i+1, mid+1, r, pos);
    t[i] = t[2*i] + t[2*i+1];

}

void fill_dp(int l, int r)
{
    dp[1][0] = 1;
    int i, j, maxsum = p[r] - p[l-1], idx = 0, pridx = 1;
    for (i=l; i<=r; ++i)
    {
        for (j=0; j<=maxsum; ++j)
        {
            dp[idx][j] = dp[pridx][j];
            if (j-a[i] >= 0 && dp[pridx][j-a[i]])
                dp[idx][j] = true;
        }

        idx = idx + pridx;
        pridx = idx - pridx;
        idx = idx - pridx;
    }
    idx_dp = pridx;
}

void add_dp(int from, int to, int l, int r)
{
    int i, j, maxsum = p[r] - p[l-1], idx, pridx;
    if (idx_dp == 1) idx = 0, pridx = 1;
    else idx = 1, pridx = 0;
    for (i=from; i<=to; ++i)
    {
        for (j=0; j<=maxs; ++j)
        {
            dp[idx][j] = dp[pridx][j];
            if (j-a[i] >= 0 && dp[pridx][j-a[i]] && !dp[idx][j])
            {
                dp[idx][j] = true;
                update(1, 1, maxs, j);
            }
        }

        idx = idx + pridx;
        pridx = idx - pridx;
        idx = idx - pridx;
    }
    idx_dp = pridx;
}

void solve()
{
    sort(q+1, q+k+1, cmp);
    int i;
    lead[1] = 1;
    for (i=2; i<=k; ++i)
    {
        if (q[i].l >= q[i-1].l && q[i].r <= q[i-1].r)
            lead[i] = i-1;
        else lead[i] = i;
        //cout << q[i].l << " " << q[i].r << "   " << q[i-1].l << " " << q[i-1].r << "    " << i << " -> " << lead[i] << endl;
    }

    for (i=k; i>0; --i)
    {
        if (lead[i+1] != i)
        {
            memset(dp[0], 0, sizeof(dp[0]));
            memset(dp[1], 0, sizeof(dp[1]));
            fill_dp(q[i].l, q[i].r);
            make_tree(1, 1, maxs);
            ql = q[i].x, qr = q[i].y;
            ans[q[i].idx] = query_sum(1, 1, maxs);
        }
        else
        {
            if (q[i].l != q[i+1].l) add_dp(q[i].l, q[i+1].l-1, q[i].l, q[i].r);
            if (q[i].r != q[i+1].r) add_dp(q[i+1].r+1, q[i].r, q[i].l, q[i].r);
            ql = q[i].x, qr = q[i].y;
            ans[q[i].idx] = query_sum(1, 1, maxs);
        }
    }
}

void print()
{
    for (int i=1; i<=k; ++i)
        cout << ans[i] << '\n' ;
}

int main()
{
    read();
    solve();
    print();
    return 0;
}