#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXN = 10000000 + 10;
const int INF  = 1e9;

llong n;
bool isComposite[MAXN];
std::vector <llong> primes;
void solve()
{
    llong ans = 0;
    for (int i = (int)primes.size() - 1 ; i >= 0 ; --i)
    {
        ans += n / (primes[i] * primes[i]) - ans / (primes[i] * primes[i]);
    }

    std::cout << n - ans << '\n';
}

void input()
{
    std::cin >> n;
}

void initialize()
{
    n = 10000000;
    for (llong i = 2 ; i <= n ; ++i)
    {
        if (isComposite[i])
        {
            continue;
        }

        primes.push_back(i);
        for (llong j = i * i ; j <= n ; j += i)
        {
            isComposite[j] = true;
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int tests;
int main()
{
    fastIO();
    initialize();
    std::cin >> tests;

    while (tests--)
    {
        input();
        solve();
    }

    return 0;
}
