#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXN = 10000000 + 10;
const int INF  = 1e9;

llong n;
int prefix[MAXN];
llong lowDiv[MAXN];
void solve()
{
    std::cout << n - prefix[n] << '\n';
}

void input()
{
    std::cin >> n;
}

void initialize()
{
    n = 10000000;
    std::fill(lowDiv, lowDiv + MAXN, INF);
    for (llong i = 2 ; i <= n ; ++i)
    {
        if (lowDiv[i] != INF)
        {
            continue;
        }

        lowDiv[i] = i;
        for (llong j = i * i ; j <= n ; j += i)
        {
            lowDiv[j] = std::min(lowDiv[j], i);
        }
    }

    llong ans = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        int num = i;
        bool bad = false;
        while (num > 1)
        {
            if (i % (lowDiv[num] * lowDiv[num]) == 0)
            {
                bad = true;
                break;
            }

            num /= lowDiv[num];
        }

        ans += bad;
        prefix[i] = ans;
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int tests;
int main()
{
    fastIO();
    initialize();
    std::cin >> tests;

    while (tests--)
    {
        input();
        solve();
    }

    return 0;
}
