#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXN = 10000000 + 10;
const int INF  = 1e9;

llong n;
llong ans;
bool isComposite[MAXN];
std::vector <llong> primes;

void brute(int pos, int cnt, llong prod)
{
    if (pos == primes.size() || prod > n / primes[pos])
    {
        if (cnt) ans -= n / prod;
        else ans += n / prod;
        return;
    }

    brute(pos + 1, cnt, prod);
    brute(pos + 1, cnt ^ 1, prod * primes[pos]);
}

void solve()
{
    ans = 0;
    brute(0, 0, 1);
    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n;
}

void initialize()
{
    n = 10000000;
    for (llong i = 2 ; i <= n ; ++i)
    {
        if (isComposite[i])
        {
            continue;
        }

        primes.push_back(i * i);
        for (llong j = i * i ; j <= n ; j += i)
        {
            isComposite[j] = true;
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int tests;
int main()
{
    fastIO();
    initialize();
    std::cin >> tests;

    while (tests--)
    {
        input();
        solve();
    }

    return 0;
}
