#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <bitset>

typedef long long llong;
const int MAXS = 250000 + 10;
const int MAXQ = 1500000 + 10;
const int MAXN = 500 + 10;
const int INF  = 1e9;

struct Query
{
    int a, b, r, idx;
};

int n, q;
int x[MAXN];
int ans[MAXQ];
std::bitset <MAXS> prefix[MAXN];
std::vector <Query> queries[MAXN];

void answerQueries(int l)
{
    prefix[l - 1].reset(); prefix[l - 1][0] = 1;
    for (int i = l ; i <= n ; ++i)
    {
        prefix[i] = prefix[i - 1] << x[i];
    }
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        answerQueries(i);
    }
}

void output()
{
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cout << ans[i] << '\n';
    }
}

void input()
{
    int sum = 0;
    std::cin >> n >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> x[i];
        sum += x[i];
    }

    int l, r, a, b;
    for (int j = 1 ; j <= q ; ++j)
    {
        std::cin >> l >> r >> a >> b;
        if (a > sum) continue;
        b = std::min(b, sum);
        queries[l].push_back({a, b, l, j});
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}
