#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <bitset>

#pragma GCC optimize ("O3,fast-math")
#pragma GCC target ("sse4")

typedef long long llong;
const int MAXS = 160000 + 10;
const int MAXQ = 1500000 + 10;
const int MAXN = 500 + 10;
const int INF  = 1e9;

struct BIT
{
    int tree[MAXS];
    void reset()
    {
        std::fill(tree, tree + MAXS, 0);
    }

    inline void update(int idx, int val)
    {
        for (int pos = idx ; pos < MAXS ; pos += pos & (-pos))
        {
            tree[pos] += val;
        }
    }

    inline int query(int idx)
    {
        int ans = 0;
        for (int pos = idx ; pos > 0 ; pos -= pos & (-pos))
        {
            ans += tree[pos];
        }

        return ans;
    }
};

BIT tree;
struct Query
{
    int a, b, r, idx;
};

struct Query2
{
    int r, idx;
};

int sum;
int n, q;
int x[MAXN];
int ans[MAXQ];
int val[MAXS];
int ptr[MAXS];
bool calced[MAXN];
std::bitset <MAXS> prefix[MAXN];
std::vector <Query> queries[MAXN];
std::vector <Query2> toAns[MAXS];

inline int getBit(int pos, int bit)
{
    if (!calced[pos])
    {
        getBit(pos - 1, bit);
        calced[pos] = true;
        prefix[pos] = prefix[pos - 1] | prefix[pos - 1] << x[pos];
    }

    return prefix[pos][bit];
}

void answerQueries(int l)
{
    std::fill(calced + 1, calced + n + 1, false);
    prefix[l - 1].reset(); prefix[l - 1][0] = 1;
    calced[l - 1] = true;

    for (int k = 1 ; k <= sum ; ++k)
    {
        ptr[k] = std::max(ptr[k], l);
        while (ptr[k] <= n && !getBit(ptr[k], k))
        {
            ptr[k]++;
        }

        val[k] = ptr[k];
        toAns[k].clear();
    }

    for (const Query &curr : queries[l])
    {
        toAns[curr.b].push_back({curr.r, curr.idx});
        toAns[curr.a].push_back({-curr.r, curr.idx});
    }

    tree.reset();
    for (int i = 1 ; i <= sum ; ++i)
    {
        tree.update(val[i], 1);
        for (const Query2 &curr : toAns[i])
        {
            if (curr.r < 0) ans[curr.idx] -= tree.query(-curr.r);
            else ans[curr.idx] += tree.query(curr.r);
        }
    }
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        answerQueries(i);
    }
}

void output()
{
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cout << ans[i] << '\n';
    }
}

void input()
{
    std::cin >> n >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> x[i];
        sum += x[i];
    }

    int l, r, a, b;
    for (int j = 1 ; j <= q ; ++j)
    {
        std::cin >> l >> r >> a >> b;
        if (a > sum) continue;
        a--; b = std::min(b, sum);
        queries[l].push_back({a, b, r, j});
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();
    output();

    return 0;
}
